function testIstioPodCount() {
    local gatewayPodCount gatewayExpectedPodCount istiodPodCount istiodExpectedPodCount replicaCount podCount validTestRailIds requestedTestRailIds
    gatewayExpectedPodCount=$1
    istiodExpectedPodCount=$2
    requestedTestRailIds=$3
    validTestRailIds=("1621314" "1621315" "1663792" "1663800")
    for validTestRailId in "${validTestRailIds[@]}"; do
        if [[ "${requestedTestRailIds}" =~ "${validTestRailId}" ]]; then
            result="false";
            replicaCount=$(fetchReplicaCount deploy istio-system istiod)
            if [[ -z $replicaCount && -z $gatewayExpectedPodCount && -z $istiodExpectedPodCount ]]; then
                result="true"
                appendOutput "${validTestRailId}" "${result}"
                return
            fi
            istiodPodCount=$(kubectl -n istio-system get pods --field-selector=status.phase=Running --selector=app=istiod --output json | jq -j ".items | length")
            if [[ ${istiodPodCount} -ge ${istiodExpectedPodCount} && ${istiodPodCount} -le ${replicaCount} ]]; then
                result="true"
            fi

            gatewayPodCount=$(kubectl -n istio-system get pods --field-selector=status.phase=Running --selector=app=istio-ingressgateway --output json | jq -j ".items | length")
            if [[ ${gatewayPodCount} -ge ${gatewayExpectedPodCount} && "${result}" == "true" ]]; then
                result="true"
            fi

            appendOutput "${validTestRailId}" "${result}"
        fi
    done
}

function setIstioValidationParam() {
    local validationStage
    validationStage=$1
    case "$validationStage" in
    3nodeup)
        gatewayPodCount=3
        istiodPodCount=2
        testRailIds="1621314"
        ;;
     rebootAllServers)
        gatewayPodCount=3
        istiodPodCount=2
        testRailIds="1621315"
        ;;
    2nodeup)
        gatewayPodCount=2
        istiodPodCount=2
        testRailIds="1663792"
        ;;
    1nodeup|0nodeup)
        gatewayPodCount=""
        istiodPodCount=""
        testRailIds="1663800"
        ;;
    *)
        echo "Unexpected option ${validationStage} passed to ${FUNCNAME[0]}"
        exit 1
        ;;
    esac
}

function executeIstioTest() {
    setIstioValidationParam "${VALIDATE_STAGE}"
    testIstioPodCount "${gatewayPodCount}" "${istiodPodCount}" "${testRailIds}"
}